<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>DUNE Warm Interface Board: /home/dan/work/DUNE/dune-wib.firmware/trunk/src/SC/DQM.vhd Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">DUNE Warm Interface Board
   </div>
   <div id="projectbrief">Firmware for the DUNE Warm Interface Board (WIB)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Design&#160;Unit&#160;List</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_27da0bc146adfd612b4e7f294317113b.html">SC</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">DQM.vhd</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="vhdlkeyword">library </span><span class="keywordflow">ieee</span>;</div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="vhdlkeyword">use </span>ieee.std_logic_1164.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="vhdlkeyword">use </span>IEEE.numeric_std.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="vhdlkeyword">use </span>IEEE.std_logic_misc.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classWIB__Constants.html">WIB_Constants</a>.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classCOLDATA__IO.html">COLDATA_IO</a>.<span class="vhdlkeyword">all</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">--</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classFEMB__DAQ__IO.html">FEMB_DAQ_IO</a>.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classConvert__IO.html">Convert_IO</a>.<span class="vhdlkeyword">all</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">--use work.EB_IO.<span class="vhdlkeyword">all</span>;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classtypes.html">types</a>.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="vhdlkeyword">use </span>work.DQM_Packet.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classDQM__IO.html">DQM_IO</a>.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classWIB__IO.html">WIB_IO</a>.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div>
<div class="line"><a name="l00017"></a><span class="lineno"><a class="code" href="classDQM.html">   17</a></span>&#160;<span class="keywordflow">entity </span><a class="code" href="classDQM.html">DQM</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;  <span class="vhdlkeyword">port</span> <span class="vhdlchar">(</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="vhdlchar">clk_128Mhz</span> <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <span class="vhdlchar">reset</span>      <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="vhdlchar">convert</span> <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="vhdlchar">convert_t</span>;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="vhdlchar">WIB_ID</span>  <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="vhdlchar">WIB_ID_t</span>;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="vhdlchar">packet_out</span>  <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="vhdlchar">DQM_Packet_t</span>;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="vhdlchar">packet_free</span> <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="vhdlchar">monitor</span>  <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="vhdlchar">DQM_Monitor_t</span>;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="vhdlchar">control</span>  <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="vhdlchar">DQM_Control_t</span>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="vhdlchar">FEMB_DQM</span> <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="vhdlchar">FEMB_DQM_t</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlkeyword">entity</span> <span class="vhdlchar">DQM</span>;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="code" href="classDQM_1_1behavioral.html">   35</a></span>&#160;<span class="vhdlkeyword">architecture</span> behavioral <span class="vhdlkeyword">of</span> <a class="code" href="classDQM.html">DQM</a> is</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keyword">  -------------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keyword">  --components</span><span class="keyword"></span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">  -------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;  <span class="vhdlkeyword">component</span> <a class="code" href="classDQM__FIFO.html">DQM_FIFO</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="vhdlkeyword">port</span> (</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;      clock : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;      data  : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span> (<span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;      rdreq : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;      wrreq : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;      empty : <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;      full  : <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;      q     : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span> (<span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>));</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">component</span> <span class="vhdlchar">DQM_FIFO</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">  -------------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">  -- signals</span><span class="keyword"></span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="keyword">  -------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">fifo_in</span>  <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">fifo_out</span> <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">fifo_rd</span>  <span class="vhdlchar">:</span> <span class="comment">std_logic</span>                     <span class="vhdlchar">:=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">fifo_wr</span>  <span class="vhdlchar">:</span> <span class="comment">std_logic</span>                     <span class="vhdlchar">:=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;  <span class="vhdlkeyword">type</span> <span class="vhdlchar">DQMS_state_t</span> <span class="vhdlkeyword">is</span> <span class="vhdlchar">(</span><span class="vhdlchar">DQMS_S_IDLE</span><span class="vhdlchar">,</span> <span class="vhdlchar">DQMS_S_WAIT_FOR_UDP_PACKET</span><span class="vhdlchar">,</span> <span class="vhdlchar">DQMS_S_WAIT_FOR_TOSEND_PACKET</span><span class="vhdlchar">,</span> <span class="vhdlchar">DQMS_S_STREAM</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">DQMS_state</span> <span class="vhdlchar">:</span> <span class="vhdlchar">DQMS_state_t</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">DQMS_S_IDLE</span>;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;  <span class="vhdlkeyword">type</span> <span class="vhdlchar">DQMC_state_t</span> <span class="vhdlkeyword">is</span> <span class="vhdlchar">(</span><span class="vhdlchar">DQMC_S_IDLE</span><span class="vhdlchar">,</span> <span class="vhdlchar">DQMC_S_WAIT_FOR_EMPTY_PACKET</span><span class="vhdlchar">,</span> <span class="vhdlchar">DQMC_S_START_PACKET</span><span class="vhdlchar">,</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;                        <span class="vhdlchar">DQMC_S_JACK</span><span class="vhdlchar">,</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;                        <span class="vhdlchar">DQMC_S_CD_SINGLESTREAM_START</span><span class="vhdlchar">,</span> <span class="vhdlchar">DQMC_S_CD_SINGLESTREAM_WAIT</span><span class="vhdlchar">,</span> <span class="vhdlchar">DQMC_S_CD_SINGLESTREAM_CAPTURE</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">DQMC_state</span> <span class="vhdlchar">:</span> <span class="vhdlchar">DQMC_state_t</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">DQMC_S_IDLE</span>;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">write_index</span> <span class="vhdlchar">:</span> <span class="comment">integer</span> <span class="vhdlkeyword">range</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span> <span class="vhdlchar">:=</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span>;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">read_index</span>  <span class="vhdlchar">:</span> <span class="comment">integer</span> <span class="vhdlkeyword">range</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span> <span class="vhdlchar">:=</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">mem_switch</span>  <span class="vhdlchar">:</span> <span class="comment">std_logic</span>                <span class="vhdlchar">:=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">packet_out_fifo_wr_delay</span> <span class="vhdlchar">:</span> <span class="comment">std_logic</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">packet_system_status</span>    <span class="vhdlchar">:</span> <span class="vhdlchar">uint32_array_t</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">packet_header_user_info</span> <span class="vhdlchar">:</span> <span class="vhdlchar">uint64_array_t</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">packet_size</span>             <span class="vhdlchar">:</span> <span class="vhdlchar">uint16_array_t</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">size_left</span>               <span class="vhdlchar">:</span> <span class="comment">unsigned</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>      <span class="vhdlchar">:=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;0000&quot;</span>;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">stream_number</span> <span class="vhdlchar">:</span> <span class="comment">integer</span> <span class="vhdlkeyword">range</span> <span class="vhdlchar">LINK_COUNT</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span>;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="keyword">  --other signals</span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">jack_counter</span> <span class="vhdlchar">:</span> <span class="comment">unsigned</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;00&quot;</span>;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">jack_start</span> <span class="vhdlchar">:</span> <span class="comment">unsigned</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;00&quot;</span>;</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">jack_end</span> <span class="vhdlchar">:</span> <span class="comment">unsigned</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;00&quot;</span>;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;  </div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;  </div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="vhdlkeyword">begin </span><span class="keyword"> -- <span class="vhdlkeyword">architecture</span> behavioral</span></div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;  <span class="vhdlchar">monitor</span><span class="vhdlchar">.</span><span class="vhdlchar">enable_DQM</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">enable_DQM</span>;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;  <span class="vhdlchar">monitor</span><span class="vhdlchar">.</span><span class="vhdlchar">DQM_type</span>   <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">DQM_type</span>;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;  <span class="vhdlchar">monitor</span><span class="vhdlchar">.</span><span class="vhdlchar">CD_SS</span>      <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">CD_SS</span>;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;  DQM_FIFO_1 : <a class="code" href="classDQM__FIFO.html">DQM_FIFO</a></div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span> (</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;      clock  =&gt; clk_128Mhz,</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;      data   =&gt; fifo_in,</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;      rdreq  =&gt; fifo_rd,</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;      wrreq  =&gt; fifo_wr,</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;      empty  =&gt; <span class="vhdlkeyword">open</span>,</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;      full   =&gt; <span class="vhdlkeyword">open</span>,</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;      q      =&gt; fifo_out<span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;  local_fifo_to_remote_fifo: <span class="vhdlkeyword">process</span> (clk_128Mhz, reset) <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;<span class="vhdlkeyword">  begin </span><span class="keyword"> -- <span class="vhdlkeyword">process</span> local_fifo_to_remote_fifo</span></div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <span class="vhdlkeyword">if</span> <span class="vhdlchar">reset</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword">                 -- asynchronous reset (active high)</span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;      <span class="vhdlchar">packet_out</span><span class="vhdlchar">.</span><span class="vhdlchar">fifo_wr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;      <span class="vhdlchar">packet_out_fifo_wr_delay</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">clk_128Mhz</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">event</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">clk_128Mhz</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword">  -- rising clock edge</span><span class="keyword"></span></div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="keyword">      -- setup correct delay <span class="vhdlkeyword">for</span> output data</span></div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;      <span class="vhdlchar">packet_out_fifo_wr_delay</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">fifo_rd</span>;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;      <span class="vhdlchar">packet_out</span><span class="vhdlchar">.</span><span class="vhdlchar">fifo_wr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">packet_out_fifo_wr_delay</span>;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;      <span class="vhdlchar">packet_out</span><span class="vhdlchar">.</span><span class="vhdlchar">fifo_data</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">fifo_out</span>;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">process</span> <span class="vhdlchar">local_fifo_to_remote_fifo</span>;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;  </div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;  DQM_send : <span class="vhdlkeyword">process</span> (clk_128Mhz, reset) <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="vhdlkeyword">  begin </span><span class="keyword"> -- <span class="vhdlkeyword">process</span> DQM_send</span></div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="vhdlkeyword">if</span> <span class="vhdlchar">reset</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword">                 -- asynchronous reset (active high)</span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">clk_128Mhz</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">event</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">clk_128Mhz</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword">  -- rising clock edge</span></div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;      <span class="vhdlkeyword">case</span> <span class="vhdlchar">DQMS_state</span> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="vhdlkeyword">when</span> <span class="vhdlchar">DQMS_S_IDLE</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span><span class="keyword"></span></div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="keyword">          -- Idle state that waits <span class="vhdlkeyword">for</span> DQM <span class="vhdlkeyword">to</span> be enabled</span></div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;          <span class="vhdlchar">DQMS_state</span>         <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">DQMS_S_IDLE</span>;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="keyword">          --Check <span class="vhdlkeyword">if</span> we are sending DQM</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;          <span class="vhdlkeyword">if</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">enable_DQM</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;            <span class="vhdlchar">DQMS_state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">DQMS_S_WAIT_FOR_UDP_PACKET</span>;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;          <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        <span class="vhdlkeyword">when</span> <span class="vhdlchar">DQMS_S_WAIT_FOR_UDP_PACKET</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span></div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;          <span class="vhdlkeyword">if</span> <span class="vhdlchar">packet_free</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;            <span class="vhdlchar">DQMS_state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">DQMS_S_WAIT_FOR_TOSEND_PACKET</span>;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;          <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        <span class="vhdlkeyword">when</span> <span class="vhdlchar">DQMS_S_WAIT_FOR_TOSEND_PACKET</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span><span class="keyword"></span></div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;<span class="keyword">          --Wait <span class="vhdlkeyword">for</span> the builder <span class="vhdlkeyword">process</span> <span class="vhdlkeyword">to</span> hand us a packet</span></div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;          <span class="vhdlkeyword">if</span> <span class="vhdlchar">mem_switch</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">packet_size</span><span class="vhdlchar">(</span><span class="vhdlchar">read_index</span><span class="vhdlchar">)</span> <span class="vhdlchar">/=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;0000&quot;</span> <span class="vhdlkeyword">then</span><span class="keyword"></span></div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;<span class="keyword">            --Update packet header info <span class="vhdlkeyword">for</span> UDP core </span></div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;            <span class="vhdlchar">packet_out</span><span class="vhdlchar">.</span><span class="vhdlchar">system_status</span>    <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">packet_system_status</span><span class="vhdlchar">(</span><span class="vhdlchar">read_index</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;            <span class="vhdlchar">packet_out</span><span class="vhdlchar">.</span><span class="vhdlchar">header_user_info</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">packet_header_user_info</span><span class="vhdlchar">(</span><span class="vhdlchar">read_index</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="keyword">            --Begin streaming local FIFO <span class="vhdlkeyword">to</span> UDP core</span></div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;            <span class="vhdlchar">size_left</span>  <span class="vhdlchar">&lt;=</span> <span class="comment">unsigned</span><span class="vhdlchar">(</span><span class="vhdlchar">packet_size</span><span class="vhdlchar">(</span><span class="vhdlchar">read_index</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> ;</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;            <span class="vhdlchar">fifo_rd</span>    <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;            <span class="vhdlchar">DQMS_state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">DQMS_S_STREAM</span>;</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;          <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        <span class="vhdlkeyword">when</span> <span class="vhdlchar">DQMS_S_STREAM</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span><span class="keyword"></span></div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="keyword">          --Stream <span class="vhdlkeyword">out</span> data</span><span class="keyword"></span></div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;<span class="keyword">          --This take place <span class="vhdlkeyword">in</span> local_fifo_to_remote_fifo <span class="vhdlkeyword">process</span> above</span></div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160; <span class="keyword"></span></div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;<span class="keyword">          --Wait <span class="vhdlkeyword">for</span> <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">of</span> data.</span></div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;          <span class="vhdlchar">size_left</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">size_left</span> <span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span>;</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;          <span class="vhdlkeyword">if</span> <span class="vhdlchar">size_left</span> <span class="vhdlchar">=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;0001&quot;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            <span class="vhdlchar">fifo_rd</span>    <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;            <span class="vhdlchar">DQMS_state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">DQMS_S_IDLE</span>;</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;          <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        <span class="vhdlkeyword">when</span> <span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlkeyword">null</span>;</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;      <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">case</span>;</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">process</span> <span class="vhdlchar">DQM_send</span>;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;  DQM_caputre_manager : <span class="vhdlkeyword">process</span> (clk_128Mhz, reset) <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;<span class="vhdlkeyword">  begin </span><span class="keyword"> -- <span class="vhdlkeyword">process</span> DQM_caputre_manager</span></div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    <span class="vhdlkeyword">if</span> <span class="vhdlchar">reset</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword">                 -- asynchronous reset (active high)</span></div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;      <span class="vhdlchar">write_index</span> <span class="vhdlchar">&lt;=</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span>;</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;      <span class="vhdlchar">read_index</span>  <span class="vhdlchar">&lt;=</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>;</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">clk_128Mhz</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">event</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">clk_128Mhz</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword">  -- rising clock edge</span></div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;<span class="keyword">      -- handle swapping <span class="vhdlkeyword">of</span> memories between capture <span class="vhdlkeyword">and</span> send</span></div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;      <span class="vhdlchar">mem_switch</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;      <span class="vhdlkeyword">if</span> <span class="vhdlchar">(</span><span class="vhdlchar">DQMS_state</span> <span class="vhdlchar">=</span> <span class="vhdlchar">DQMS_S_WAIT_FOR_TOSEND_PACKET</span> <span class="vhdlkeyword">and</span></div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;          <span class="vhdlchar">DQMC_state</span> <span class="vhdlchar">=</span> <span class="vhdlchar">DQMC_S_WAIT_FOR_EMPTY_PACKET</span>  <span class="vhdlkeyword">and</span></div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;          <span class="vhdlchar">mem_switch</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">and</span><span class="keyword"> -- allow the other machines <span class="vhdlkeyword">to</span> move <span class="vhdlkeyword">to</span> the <span class="vhdlkeyword">new</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;<span class="keyword">                               -- states <span class="vhdlkeyword">after</span> mem_switch triggers them</span></div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;          <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">enable_DQM</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">then</span><span class="keyword">  -- only do this <span class="vhdlkeyword">when</span> the DQM <span class="vhdlkeyword">is</span> enabled) <span class="vhdlkeyword">then</span></span></div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        <span class="vhdlchar">write_index</span>      <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">read_index</span>;</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        <span class="vhdlchar">read_index</span>       <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">write_index</span>;</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        <span class="vhdlchar">mem_switch</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;      <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">process</span> <span class="vhdlchar">DQM_caputre_manager</span>;</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;  </div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;  DQM_capture : <span class="vhdlkeyword">process</span> (clk_128Mhz, reset) <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;<span class="vhdlkeyword">  begin </span><span class="keyword"> -- <span class="vhdlkeyword">process</span> DQM_capture</span></div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    <span class="vhdlkeyword">if</span> <span class="vhdlchar">reset</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword">                 -- asynchronous reset (active high)</span></div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;      <span class="vhdlchar">DQMC_state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">DQMC_S_IDLE</span>;</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">clk_128Mhz</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">event</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">clk_128Mhz</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword">  -- rising clock edge</span></div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;      <span class="vhdlkeyword">case</span> <span class="vhdlchar">DQMC_state</span> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        <span class="vhdlkeyword">when</span> <span class="vhdlchar">DQMC_S_IDLE</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span><span class="keyword"></span></div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;<span class="keyword">          --Check <span class="vhdlkeyword">if</span> we are sending DQM</span></div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;          <span class="vhdlkeyword">if</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">enable_DQM</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;            <span class="vhdlchar">DQMC_state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">DQMC_S_WAIT_FOR_EMPTY_PACKET</span>;</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;          <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        <span class="vhdlkeyword">when</span> <span class="vhdlchar">DQMC_S_WAIT_FOR_EMPTY_PACKET</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span><span class="keyword"></span></div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;<span class="keyword">          --Wait <span class="vhdlkeyword">for</span> the builder <span class="vhdlkeyword">process</span> <span class="vhdlkeyword">to</span> hand us a packet</span></div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;          <span class="vhdlkeyword">if</span> <span class="vhdlchar">mem_switch</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;            <span class="vhdlchar">DQMC_state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">DQMC_S_START_PACKET</span>;</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;          <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        <span class="vhdlkeyword">when</span> <span class="vhdlchar">DQMC_S_START_PACKET</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span></div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;          <span class="vhdlchar">packet_system_status</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>  <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">WIB_ID</span><span class="vhdlchar">.</span><span class="vhdlchar">crate</span>;</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;          <span class="vhdlchar">packet_system_status</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">4</span><span class="vhdlchar">)</span>  <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">WIB_ID</span><span class="vhdlchar">.</span><span class="vhdlchar">slot</span>;</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;          <span class="vhdlchar">packet_system_status</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">31</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">8</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">convert</span><span class="vhdlchar">.</span><span class="vhdlchar">time_stamp</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">23</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;          <span class="vhdlkeyword">case</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">DQM_type</span> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;            <span class="vhdlkeyword">when</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;0&quot;</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span><span class="keyword"></span></div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;<span class="keyword">              --Jack&#39;s defaults</span></div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;              <span class="vhdlchar">stream_number</span>                                          <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">to_integer</span><span class="vhdlchar">(</span><span class="comment">unsigned</span><span class="vhdlchar">(</span><span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">CD_SS</span><span class="vhdlchar">.</span><span class="vhdlchar">FEMB_number</span> <span class="vhdlchar">&amp;</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">CD_SS</span><span class="vhdlchar">.</span><span class="vhdlchar">CD_number</span> <span class="vhdlchar">&amp;</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">CD_SS</span><span class="vhdlchar">.</span><span class="vhdlchar">stream_number</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span> <span class="vhdlchar">+</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span>;</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;              <span class="vhdlchar">DQMC_state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">DQMC_S_JACK</span>;</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;              <span class="vhdlchar">fifo_in</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">x</span><span class="keyword">&quot;FACE&quot;</span>;</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;              <span class="vhdlchar">fifo_wr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;              <span class="vhdlchar">jack_counter</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;00&quot;</span>;</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;              <span class="vhdlchar">packet_size</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;01&quot;</span>;</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;              <span class="vhdlchar">packet_header_user_info</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;              <span class="vhdlkeyword">if</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">CD_SS</span><span class="vhdlchar">.</span><span class="vhdlchar">sub_stream_number</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;                <span class="vhdlchar">jack_start</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;08&quot;</span>;</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;                <span class="vhdlchar">jack_end</span>   <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;21&quot;</span>;</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;              <span class="vhdlkeyword">else</span></div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;                <span class="vhdlchar">jack_start</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;22&quot;</span>;</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;                <span class="vhdlchar">jack_end</span>   <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;39&quot;</span>;</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;              <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;            <span class="vhdlkeyword">when</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;1&quot;</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span>              </div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;              <span class="vhdlchar">DQMC_state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">DQMC_S_CD_SINGLESTREAM_WAIT</span>;</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;              <span class="vhdlchar">stream_number</span>                                          <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">to_integer</span><span class="vhdlchar">(</span><span class="comment">unsigned</span><span class="vhdlchar">(</span><span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">CD_SS</span><span class="vhdlchar">.</span><span class="vhdlchar">FEMB_number</span> <span class="vhdlchar">&amp;</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">CD_SS</span><span class="vhdlchar">.</span><span class="vhdlchar">CD_number</span> <span class="vhdlchar">&amp;</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">CD_SS</span><span class="vhdlchar">.</span><span class="vhdlchar">stream_number</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span> <span class="vhdlchar">+</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span>;</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;            <span class="vhdlkeyword">when</span> <span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span></div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;              <span class="vhdlchar">DQMC_state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">DQMC_S_START_PACKET</span>;</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;          <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">case</span>;</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;<span class="keyword">        -------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;<span class="keyword">        -- SBND version</span><span class="keyword"></span></div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;<span class="keyword">        -------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        <span class="vhdlkeyword">when</span> <span class="vhdlchar">DQMC_S_JACK</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span></div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;          <span class="vhdlchar">fifo_wr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;          <span class="vhdlkeyword">if</span> <span class="vhdlchar">jack_counter</span> <span class="vhdlchar">=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;00&quot;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;            <span class="vhdlkeyword">if</span> <span class="vhdlchar">FEMB_DQM</span><span class="vhdlchar">.</span><span class="vhdlchar">COLDATA_stream</span><span class="vhdlchar">(</span><span class="vhdlchar">stream_number</span><span class="vhdlchar">)</span> <span class="vhdlchar">=</span> <span class="vhdlchar">SOF_CHARACTER</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;              <span class="vhdlchar">jack_counter</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;01&quot;</span>;</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;            <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;          <span class="vhdlkeyword">else</span>                      </div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;            <span class="vhdlchar">jack_counter</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">jack_counter</span> <span class="vhdlchar">+</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span>;</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;            <span class="vhdlkeyword">if</span> <span class="vhdlchar">jack_counter</span> <span class="vhdlchar">&gt;=</span> <span class="vhdlchar">jack_start</span> <span class="vhdlkeyword">then</span> <span class="keyword"></span></div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;<span class="keyword">              --jack_counter <span class="vhdlkeyword">is</span> greater than </span><span class="vhdllogic">8</span>, so send the sample data<span class="keyword"></span></div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;<span class="keyword">              -- the fifo we are writing <span class="vhdlkeyword">to</span> <span class="vhdlkeyword">is</span> </span><span class="vhdllogic">16</span> bits, but the data <span class="vhdlkeyword">is</span> 8bit,<span class="keyword"></span></div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;<span class="keyword">              -- so we <span class="vhdlkeyword">use</span> the LSB <span class="vhdlkeyword">of</span> jack_counter <span class="vhdlkeyword">to</span> write every other word</span><span class="keyword"></span></div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;<span class="keyword">              -- <span class="vhdlkeyword">and</span> we fill the </span><span class="vhdllogic">16</span> <span class="comment">bit</span> written word 8bits at a <span class="comment">time</span>.</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;              <span class="vhdlkeyword">if</span> <span class="vhdlchar">jack_counter</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;                <span class="vhdlchar">fifo_in</span><span class="vhdlchar">(</span> <span class="vhdllogic"></span><span class="vhdllogic">7</span> <span class="vhdlkeyword">downto</span>  <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">FEMB_DQM</span><span class="vhdlchar">.</span><span class="vhdlchar">COLDATA_stream</span><span class="vhdlchar">(</span><span class="vhdlchar">stream_number</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;              <span class="vhdlkeyword">else</span></div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;                <span class="vhdlchar">fifo_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span>  <span class="vhdllogic"></span><span class="vhdllogic">8</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">FEMB_DQM</span><span class="vhdlchar">.</span><span class="vhdlchar">COLDATA_stream</span><span class="vhdlchar">(</span><span class="vhdlchar">stream_number</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;                <span class="vhdlchar">fifo_wr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;                <span class="vhdlchar">packet_size</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="comment">unsigned</span><span class="vhdlchar">(</span><span class="vhdlchar">packet_size</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span> <span class="vhdlchar">+</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span>;   </div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;              <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;            <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;<span class="keyword">            -- <span class="vhdlkeyword">End</span> <span class="vhdlkeyword">of</span> data</span></div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;            <span class="vhdlkeyword">if</span> <span class="vhdlchar">jack_counter</span> <span class="vhdlchar">=</span> <span class="vhdlchar">jack_end</span> <span class="vhdlkeyword">then</span><span class="keyword"> --x&quot;39&quot; <span class="vhdlkeyword">then</span> --0x22</span></div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;              <span class="vhdlchar">fifo_wr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;              <span class="vhdlchar">DQMC_state</span>               <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">DQMC_S_IDLE</span>;</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;            <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;          <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;<span class="keyword">        -------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;<span class="keyword">        -- COLDATA single stream capture mode <span class="vhdlkeyword">begin</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;<span class="keyword">        -------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;        <span class="vhdlkeyword">when</span> <span class="vhdlchar">DQMC_S_CD_SINGLESTREAM_WAIT</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span></div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;          <span class="vhdlkeyword">if</span> <span class="vhdlchar">FEMB_DQM</span><span class="vhdlchar">.</span><span class="vhdlchar">COLDATA_stream</span><span class="vhdlchar">(</span><span class="vhdlchar">stream_number</span><span class="vhdlchar">)</span> <span class="vhdlchar">=</span> <span class="vhdlchar">SOF_CHARACTER</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;<span class="keyword">            --Cache info <span class="vhdlkeyword">for</span> packet header</span></div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;            <span class="vhdlchar">packet_header_user_info</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>  <span class="vhdlchar">&lt;=</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">convert</span><span class="vhdlchar">.</span><span class="vhdlchar">convert_count</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;            <span class="vhdlchar">packet_header_user_info</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">19</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">16</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;0&quot;</span>;</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;            <span class="vhdlchar">packet_header_user_info</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">20</span><span class="vhdlchar">)</span>           <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">CD_SS</span><span class="vhdlchar">.</span><span class="vhdlchar">stream_number</span>;</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;            <span class="vhdlchar">packet_header_user_info</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">21</span><span class="vhdlchar">)</span>           <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">CD_SS</span><span class="vhdlchar">.</span><span class="vhdlchar">CD_number</span>;</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;            <span class="vhdlchar">packet_header_user_info</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">23</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">22</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">CD_SS</span><span class="vhdlchar">.</span><span class="vhdlchar">FEMB_number</span>;</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;            <span class="vhdlchar">packet_header_user_info</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">59</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">24</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;000000000&quot;</span>;</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;            <span class="vhdlchar">packet_header_user_info</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">63</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">60</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;0&quot;</span>;</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;            <span class="keyword"></span></div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;<span class="keyword">            --Start streaming the data</span></div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;            <span class="vhdlchar">fifo_wr</span>                  <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;            <span class="vhdlchar">fifo_in</span>                  <span class="vhdlchar">&lt;=</span> <span class="vhdllogic">&quot;0000000&quot;</span> <span class="vhdlchar">&amp;</span> <span class="vhdlchar">FEMB_DQM</span><span class="vhdlchar">.</span><span class="vhdlchar">COLDATA_Stream</span><span class="vhdlchar">(</span><span class="vhdlchar">stream_number</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">8</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;            <span class="vhdlchar">packet_size</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;01&quot;</span>;</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;            <span class="vhdlchar">DQMC_state</span>               <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">DQMC_S_CD_SINGLESTREAM_CAPTURE</span>;</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;          <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;        <span class="vhdlkeyword">when</span> <span class="vhdlchar">DQMC_S_CD_SINGLESTREAM_CAPTURE</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span></div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;          <span class="vhdlchar">fifo_wr</span>                  <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;          <span class="vhdlchar">fifo_in</span>                  <span class="vhdlchar">&lt;=</span> <span class="vhdllogic">&quot;0000000&quot;</span> <span class="vhdlchar">&amp;</span> <span class="vhdlchar">FEMB_DQM</span><span class="vhdlchar">.</span><span class="vhdlchar">COLDATA_Stream</span><span class="vhdlchar">(</span><span class="vhdlchar">stream_number</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">8</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;          <span class="vhdlchar">packet_size</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="comment">unsigned</span><span class="vhdlchar">(</span><span class="vhdlchar">packet_size</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span> <span class="vhdlchar">+</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;          </div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;          <span class="vhdlkeyword">if</span> <span class="vhdlchar">(</span><span class="vhdlchar">(</span><span class="vhdlchar">CDA_SWITCH</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">packet_size</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span> <span class="vhdlchar">=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;00&quot;</span><span class="vhdlchar">&amp;</span><span class="vhdllogic">&quot;00&quot;</span><span class="vhdlchar">&amp;</span><span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CDA_FRAME_SIZE</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">or</span></div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;              <span class="vhdlchar">(</span><span class="vhdlchar">CDA_SWITCH</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">packet_size</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span> <span class="vhdlchar">=</span> <span class="vhdlchar">x</span><span class="vhdllogic">&quot;00&quot;</span><span class="vhdlchar">&amp;</span><span class="vhdllogic">&quot;00&quot;</span><span class="vhdlchar">&amp;</span><span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CDF_FRAME_SIZE</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">or</span></div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;              </div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;              <span class="vhdlchar">(</span><span class="vhdlchar">FEMB_DQM</span><span class="vhdlchar">.</span><span class="vhdlchar">COLDATA_Stream</span><span class="vhdlchar">(</span><span class="vhdlchar">stream_number</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">8</span><span class="vhdlchar">)</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlchar">)</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;            <span class="vhdlchar">DQMC_state</span>               <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">DQMC_S_IDLE</span>;</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;            <span class="vhdlchar">fifo_wr</span>                  <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;            <span class="vhdlchar">packet_size</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">packet_size</span><span class="vhdlchar">(</span><span class="vhdlchar">write_index</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;          <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;<span class="keyword">        -------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;<span class="keyword">        -- COLDATA single stream capture mode <span class="vhdlkeyword">end</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;<span class="keyword">        -------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;        <span class="vhdlkeyword">when</span> <span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlkeyword">null</span>;</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;      <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">case</span>;</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">process</span> <span class="vhdlchar">DQM_capture</span>;</div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;</div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;</div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;</div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlkeyword">architecture</span> <span class="vhdlchar">behavioral</span>;</div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Nov 1 2017 10:40:31 for DUNE Warm Interface Board by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1
</small></address>
</body>
</html>
